package com.adc.da.vdaims.util;

//import org.jeecgframework.core.util.StringUtil;
import org.krysalis.barcode4j.HumanReadablePlacement;
import org.krysalis.barcode4j.impl.code128.Code128Bean;
import org.krysalis.barcode4j.output.bitmap.BitmapCanvasProvider;
import org.krysalis.barcode4j.tools.UnitConv;

import java.awt.image.BufferedImage;
import java.io.*;

/**
 * @author zer0
 *
 */
public class BarcodeUtil {

	 /**
     * 生成文件
     *
     * @param msg
     * @param path
     * @return
     */
    public static File generateFile(String msg, String path, String fileName) {
        File dict = new File(path);
        if (!dict.exists()) {
        	dict.mkdirs();
		}
        
        String file = path + fileName + ".png";
        
        try {
            generate(msg, new FileOutputStream(file));
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        }
        
        return new File(file);
    }
    
    /**
     * 生成文件国六
     *
     * @param msg
     * @param path
     * @return
     */
    public static File generateFileS(String msg, String path, String fileName) {
        File dict = new File(path);
        if (!dict.exists()) {
        	dict.mkdirs();
		}
        
        String file = path + fileName + ".png";
        
        try {
            generateS(msg, new FileOutputStream(file));
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        }
        
        return new File(file);
    }
 
    /**
     * 生成字节
     *
     * @param msg
     * @return
     */
    public static byte[] generate(String msg) {
        ByteArrayOutputStream ous = new ByteArrayOutputStream();
        generate(msg, ous);
        return ous.toByteArray();
    }
 
    /**
     * 生成到流
     *
     * @param msg
     * @param ous
     */
    public static void generate(String msg, OutputStream ous) {
//        if (StringUtil.isEmpty(msg) || ous == null) {
//            return;
//        }
        if (msg == null || "".equals(msg) || ous == null) {
            return;
        }
        Code128Bean bean = new Code128Bean();
 
        // 精细度
        final int dpi =600;
        // module宽度
        final double moduleWidth = UnitConv.in2mm(8.0f / dpi);
 
        // 配置对象
       /* bean.setModuleWidth(0.3);
        bean.setQuietZone(0);
        bean.doQuietZone(true);
        bean.setBarHeight(10);
        bean.setVerticalQuietZone(0);
        bean.setFontName("Helvetica");
        bean.setFontSize(4);*/
        //bean.setModuleWidth(0.2);
        bean.setQuietZone(0);
        bean.doQuietZone(true);
        bean.setBarHeight(10);
        bean.setModuleWidth(0.25);
        bean.setHeight(4.7);
        bean.setBarHeight(12);
        bean.setFontName("Arial");
        bean.setFontSize(3);
        bean.setMsgPosition(HumanReadablePlacement.HRP_BOTTOM);
 
        String format = "image/png";
        try {
 
            // 输出到流
            BitmapCanvasProvider canvas = new BitmapCanvasProvider(ous, format, dpi,
                    BufferedImage.TYPE_BYTE_BINARY, false, 0);
 
            // 生成条形码
            bean.generateBarcode(canvas, msg);
 
            // 结束绘制
            canvas.finish();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }finally{
        	try {
				ous.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
        }
    }
	
    /**
     * 生成到流国六
     *
     * @param msg
     * @param ous
     */
    public static void generateS(String msg, OutputStream ous) {
//        if (StringUtil.isEmpty(msg) || ous == null) {
//            return;
//        }
        if (msg == null || "".equals(msg) || ous == null) {
            return;
        }

        Code128Bean bean = new Code128Bean();
 
        // 精细度
        final int dpi =600;
        // module宽度
        final double moduleWidth = UnitConv.in2mm(8.0f / dpi);
 
        // 配置对象
       /* bean.setModuleWidth(0.3);
        bean.setQuietZone(0);
        bean.doQuietZone(true);
        bean.setBarHeight(10);
        bean.setVerticalQuietZone(0);
        bean.setFontName("Helvetica");
        bean.setFontSize(4);*/
        //bean.setModuleWidth(0.2);
        bean.setQuietZone(0);
        bean.doQuietZone(true);
        bean.setModuleWidth(0.295);
        bean.setHeight(4.7);
        bean.setBarHeight(7.5);
        bean.setFontSize(0);
        bean.setMsgPosition(HumanReadablePlacement.HRP_BOTTOM);
        String format = "image/png";
        try {
 
            // 输出到流
            BitmapCanvasProvider canvas = new BitmapCanvasProvider(ous, format, dpi,
                    BufferedImage.TYPE_BYTE_BINARY, false, 0);
 
            // 生成条形码
            bean.generateBarcode(canvas, msg);
 
            // 结束绘制
            canvas.finish();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }finally{
        	try {
				ous.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
        }
    }
    public static void main(String[] args) {
		//generateFile("wj123678678", "D:/as/", "wj123");
		generateFileS("LF0E5HSE999999999", "E:/barcode/", "LF0E5HSE999999999");
	}
    
}
