package com.adc.da.vdaims.util;


import com.adc.da.vdaims.webservice.certificate.*;

public class CertificationUtils {

private static CertificateRequestServiceSoap port;

    static{
		CertificateRequestService ss = new CertificateRequestService();
        port = ss.getCertificateRequestServiceSoap();
	}
    /***
     * 上传合格证
     * @param cis
     * @return
     */
    public static OperateResult uploadInsertEnt(ArrayOfCertificateInfo cis){
    	OperateResult message = port.uploadInsertEnt(cis);
    	return message;
    }
    /***
     * 补传合格证
     * @param cis
     * @param supplementsReason
     * @return
     */
    public static OperateResult uploadOverTimeEnt(ArrayOfCertificateInfo cis,String supplementsReason){
    	OperateResult message = port.uploadOverTimeEnt(cis,supplementsReason);
    	return message;
    }
    /***
     * 修改合格证
     * @param cis
     * @param updateReason
     * @return
     */
    public static OperateResult uploadUpdateEnt(ArrayOfCertificateInfo cis,String updateReason){
    	OperateResult message = port.uploadUpdateEnt(cis,updateReason);
    	return message;
    }
    /***
     * 撤销合格证
     * @param wzhgzbhs
     * @param deleteReason
     * @return
     */
    public static OperateResult uploadDeleteEnt(ArrayOfString wzhgzbhs , String deleteReason){
    	OperateResult message = port.uploadDeleteEnt(wzhgzbhs, deleteReason);
    	return message;
    }
    /***
     * 根据完整合格证编号查询合格证信息
     * @param wzhgzbh
     * @return
     */
    public static QueryResult QueryCertificateByWZHGZBH(String wzhgzbh){
    	QueryResult queryData = port.queryCertificateByWZHGZBH(wzhgzbh);
    	return queryData;
    }

    /***
     * 根据时间段查询合格证信息
     * @param rqlx
     * @param beginTime
     * @param endTime
     * @param pageSize
     * @param pageSite
     * @return
     */
    public static QueryResult QueryCertificateByDate(int rqlx,String beginTime,String endTime,int pageSize,int pageSite){
    	QueryResult queryData = port.queryCertificateByDate(rqlx, beginTime, endTime, pageSize, pageSite);
    	return queryData;
    }

    /**
     *
     * 解析操作结果
     *
     * @param oResult
     *         操作结果  {@link OperateResult }
     *
     * @return 解析结果字符串 {@link String }


     */
    static String GetResultMessage(OperateResult oResult)
    {
    	StringBuffer sb = new StringBuffer();

    	sb.append(String.format("操作结果:%s\r\n",
    			oResult.getResultCode()));

    	for (NameValuePair nvp :
    		oResult.getResultDetail().getNameValuePair())
    	{
    		sb.append(String.format("%s:%s\r\n", nvp.getName(),
    				nvp.getValue()));
    	}
    	return sb.toString();
    }


        /**
         *
         * 解析查询结果
         *
         * @param qResult
         *         查询结果  {@link QueryResult }
         *
         * @return 解析结果字符串 {@link String }
         */
        static String GetQueryResultMessage(QueryResult qResult)
        {
        	StringBuffer sb = new StringBuffer();

        	sb.append(String.format("查询结果数:%s\r\n",
        			qResult.getCount()));

        	for (com.adc.da.vdaims.webservice.certificate.CertificateInfo ci :qResult.getData().getCertificateInfo())
        	{
        		sb.append(String.format("合格证编号:%s\r\n",
        				ci.getWZHGZBH()));
        	}
        	return sb.toString();
        }


    public static void main(String[] args) {
    	System.out.println(port.helloWorld());
    	System.out.println(port.helloWorldRemote());


    	QueryResult queryResult = port.queryCertificateByDate(2, "2018-01-20", "2018-01-25", 50, 1);
    	System.out.println(queryResult);
	}

}
