package com.adc.da.vdaims.util;

import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

public class DateUtils {

	public static SimpleDateFormat sTime = new SimpleDateFormat("yyyy-MM-dd");
	
	public static SimpleDateFormat sDate = new SimpleDateFormat("yyyy-MM");
	
	public static SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

	public static String getFromDate(Date time, boolean format) {
		if (format) {
			sdf = new SimpleDateFormat("yyyy年MM月dd日");
		}else{
			sdf = new SimpleDateFormat("yyyy年MM月dd日 HH时mm分ss秒");
		}
		String timeStr = sdf.format(time);
		return timeStr;
	}
	
	/**
	 * 功能介绍：获取当前时间yyyyMMddhhmiss格式展示出来
	 * 
	 * @return
	 */
	public static String getNowTime() {
		sdf = new SimpleDateFormat("yyyyMMddHHmmss");
		String timeStr = sdf.format(new Date());
		return timeStr;
	}

	/**
	 * 功能介绍：获取当前时间yyyyMMdd格式展示出来
	 * 
	 * @return
	 */
	public static String getNowDate() {
		sdf = new SimpleDateFormat("yyyyMMdd");
		String timeStr = sdf.format(new Date());
		return timeStr;
	}

	/***
	 * 获取服务器年月时间组合
	 * 
	 * @return
	 */
	public static String getMonthDate() {
		sdf = new SimpleDateFormat("yyyyMM");
		String timeStr = sdf.format(new Date());
		return timeStr;
	}

	public static Date getFromSelf(String time, boolean format) {
		if (format) {
			sdf = new SimpleDateFormat("yyyy-MM-dd");
		} else {
			sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		}
		Date date = null;
		try {
			date = sdf.parse(time);
		} catch (ParseException e) {
			e.printStackTrace();
		}
		return date;
	}

	/*
	 * String转timestamp
	 */
	public static Timestamp stringToStamp(String dateStr, boolean formate) throws ParseException {
		String formatest = "yyyy-MM-dd HH:mm:ss";
		if (formate) {
			formatest = "yyyy-MM-dd";
		}
		SimpleDateFormat sdf = new SimpleDateFormat(formatest);
		Date date = sdf.parse(dateStr);
		Timestamp time = new Timestamp(date.getTime());
		return time;
	}
	
	public static String getToDate(Date time, boolean format) {
		if (format) {
			sdf = new SimpleDateFormat("yyyy-MM-dd");
		}else{
			sdf = new SimpleDateFormat("yyyy-MM-dd HH：mm：ss");
		}
		String timeStr = sdf.format(time);
		return timeStr;
	}
	
	/**
	 * 指定日期按指定格式显示
	 * 
	 * @param cal
	 *            指定的日期
	 * @param pattern
	 *            指定的格式
	 * @return 指定日期按指定格式显示
	 */
	public static String formatCalToStr(Calendar cal, String pattern) {
		
		if (cal != null) {
			return new SimpleDateFormat(pattern).format(cal.getTime());

		} else {
			return "";
		}
	}
	
	/**
	 * 指定日期按指定格式显示
	 * 
	 * @param cal
	 *            指定的日期
	 * @return 指定日期按指定格式显示
	 */
	public static Date formatCalToDate(Calendar cal) {
		
		if (cal != null) {
			return cal.getTime();

		} else {
			return null;
		}
	}
	
	/***
	 * list去重
	 * @param list
	 * @return
	 */
	public static List<String> getListRank(List<String> list){
		Set<String> set = new  HashSet<String>(); 
        List<String> newList = new  ArrayList<String>(); 
        for (String cd:list) {
           if(set.add(cd)){
               newList.add(cd);
           }
        }
		return newList;
	}
	
	/***
	 * list 去重转String
	 * @param list
	 * @return
	 */
	
	public static String getListRankToString(List<String> list){
		Set<String> set = new  HashSet<String>(); 
		String str ="";
		for (String cd:list) {
			if(set.add(cd)){
				str+=cd+",";
			}
		}
		return str;
	}
	
	/**
	 * 计算时间差，以天数为单位
	 * @param startTime
	 * @param endTime
	 * @return
	 */
    public static int getDistanceTime(Date startTime, Date endTime) {
        int days = 0;
        long time1 = startTime.getTime();
        long time2 = endTime.getTime();

        long diff;
        diff = time1 - time2;
        days = (int) (diff / (24 * 60 * 60 * 1000));
        return days;
    }

    
  //获取当前周的第一天：
    public static String getFirstDayOfDay(int dayNum) {
    	Calendar calendar = Calendar.getInstance();
    	calendar.set(Calendar.DAY_OF_YEAR, calendar.get(Calendar.DAY_OF_YEAR) - dayNum);
		return sTime.format(calendar.getTime());
    }
    //获取当前周最后一天：
    public static String getLastDayOfDay(int dayNum) {
    	Calendar calendar = Calendar.getInstance();
    	calendar.set(Calendar.DAY_OF_YEAR, calendar.get(Calendar.DAY_OF_YEAR) - dayNum);
		return sTime.format(calendar.getTime());
    }
    
    //测试
    public static List<String> getDate() {
    	int num = -6;
        // 今天是一周中的第几天
        /*int dayOfWeek = c.get(Calendar.DAY_OF_WEEK );*/
        List<String> list = new ArrayList<String>();
        
        // 计算一周开始的日期
        /*c.add(Calendar.DAY_OF_MONTH, -dayOfWeek);*/
         
        for (int i = 1;i <= 7;i ++) {
        	Calendar c = Calendar.getInstance();
        	
        	if (c.getFirstDayOfWeek() == Calendar.SUNDAY) {
                c.add(Calendar.DAY_OF_MONTH, 1);
            }
        	
        	c.setTime(c.getTime());
            c.add(Calendar.DAY_OF_MONTH, num);
            list.add(sTime.format(c.getTime()));
            num ++;
        }
        return list;
    }
    
    //获取当前周的第一天：
    public static String getFirstDayOfWeek(Date time,int num) {
        Calendar cal = Calendar.getInstance();
        try {
            cal.setTime(time);
            cal.set(Calendar.DAY_OF_WEEK, num);
        } catch (Exception e) {
            e.printStackTrace();
        } 

        return sTime.format(cal.getTime());
    }
    //获取当前周最后一天：
    public static String getLastDayOfWeek(Date time,int num) {
        Calendar cal = Calendar.getInstance();
        try {
            cal.setTime(time);
            cal.set(Calendar.DAY_OF_WEEK, num);
            cal.set(Calendar.DATE, cal.get(Calendar.DATE) + 6);
        } catch(Exception e) {
            e.printStackTrace();
        }

        return sTime.format(cal.getTime());
    }
    //获取当前月第一天：
    public static String getCurrentMonthFirstDay(int num) {
        Calendar cale = Calendar.getInstance(); 
        cale.setTime(cale.getTime());
        cale = Calendar.getInstance();  
        cale.add(Calendar.MONTH , - num);
        cale.set(Calendar.DAY_OF_MONTH, 1);  
        return sTime.format(cale.getTime());
    }
    //获取当前月最后一天：
    public static String getCurrentMonthLastDay(int num) {
        Calendar cale = Calendar.getInstance();
        int month = cale.get(Calendar.MONTH) + 1;
        cale = Calendar.getInstance();  
        cale.add(Calendar.MONTH , - num);  
        cale.set(Calendar.DAY_OF_MONTH, 0);
        if(month == cale.get(Calendar.MONTH) + 1) {
        	return sTime.format(Calendar.getInstance().getTime());
        }
        return sTime.format(cale.getTime());
    }
    
    //获取当前月第一天：
    public static String getCurrentMonthFirst(int num) {
        Calendar cale = Calendar.getInstance();  
        cale = Calendar.getInstance();  
        cale.add(Calendar.MONTH , - num);  
        cale.set(Calendar.DAY_OF_MONTH, 1);  
        return sDate.format(cale.getTime());
    }
    
    /**
     * 字符串转Calendar
     * 
     * @param strDate 日期
     * @param format  格式
     * @return Calendar
     */
    public static Calendar strToCal(String strDate, String format) {
    	Date date = null;
    	Calendar calendar = null;
		try {
	    	SimpleDateFormat sdf= new SimpleDateFormat(format);
			date = sdf.parse(strDate);
	        calendar = Calendar.getInstance();
	    	calendar.setTime(date);
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	return calendar;
    }
    
   
    /**
     * 获取年
     * @param date
     * @return
     */
    public static String getYear(Date date) {
    	Calendar c = Calendar.getInstance();
    	c.setTime(date);
    	return String.valueOf(c.get(Calendar.YEAR));
    }
    
}
