package com.adc.da.vdaims.util;

import org.docx4j.XmlUtils;
import org.docx4j.dml.wordprocessingDrawing.Inline;
import org.docx4j.jaxb.Context;
import org.docx4j.openpackaging.exceptions.Docx4JException;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.openpackaging.parts.WordprocessingML.BinaryPartAbstractImage;
import org.docx4j.wml.*;

import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import java.io.*;
import java.util.*;

/**
 * @author zer0
 *
 */
public class Docx4jUtil { 
	
	public static void main(String[] args) throws Exception{
		WordprocessingMLPackage template = getTemplate("E:\\环保随车清单模板.docx");
		String replace="${qrcode}";
		
		
		
		
		File file = new File("E:\\vin454.png"); 
		byte[] bytes = convertImageToByteArray(file);
		
		//mappings.put("qrcode", bytes);
//		Docx4jUtil.variableReplace(template, mappings);
		replaceImage(template, replace, bytes, "", "");
//		Docx4jUtil.replacePlaceholder(template, "34242342", replace);
		
		Docx4jUtil.writeDocxToStream(template, "E:\\cccss.docx");
	}

	public static WordprocessingMLPackage getTemplate(String name) throws Docx4JException, FileNotFoundException {  
	    WordprocessingMLPackage template = WordprocessingMLPackage.load(new FileInputStream(new File(name)));  
	    return template;  
	}  
	
	private static List<Object> getAllElementFromObject(Object obj, Class<?> toSearch) {  
	    List<Object> result = new ArrayList<Object>();  
	    if (obj instanceof JAXBElement) obj = ((JAXBElement<?>) obj).getValue();  
	  
	    if (obj.getClass().equals(toSearch))  
	        result.add(obj);  
	    else if (obj instanceof ContentAccessor) {  
	        List<?> children = ((ContentAccessor) obj).getContent();  
	        for (Object child : children) {  
	            result.addAll(getAllElementFromObject(child, toSearch));  
	        }  
	    }  
	    return result;  
	}  
	
	public static void replacePlaceholder(WordprocessingMLPackage template, String name, String placeholder ) {  
	    List<Object> texts = getAllElementFromObject(template.getMainDocumentPart(), Text.class);  
	  
	    for (Object text : texts) {  
	        Text textElement = (Text) text;  
	        if (textElement.getValue().equals(placeholder)) {  
	            textElement.setValue(name);  
	        }  
	    }  
	}  
	
	public static void variableReplace(WordprocessingMLPackage template, HashMap<String, String> mappings) throws JAXBException, Docx4JException{
		template.getMainDocumentPart().variableReplace(mappings);
	}

	public static void writeDocxToStream(WordprocessingMLPackage template, String target) throws IOException, Docx4JException {  
	    File f = new File(target);  
	    template.save(f);  
	}  
	
	public static void replaceTable(String[] placeholders, List<Map<String, String>> textToAdd,  
            WordprocessingMLPackage template) throws Docx4JException, JAXBException {  
    List<Object> tables = getAllElementFromObject(template.getMainDocumentPart(), Tbl.class);  
  
    // 1. find the table  
    Tbl tempTable = getTemplateTable(tables, placeholders[0]);  
    List<Object> rows = getAllElementFromObject(tempTable, Tr.class);  
  
    // first row is header, second row is content  
    if (rows.size() == 2) {  
        // this is our template row  
        Tr templateRow = (Tr) rows.get(1);  
  
        for (Map<String, String> replacements : textToAdd) {  
            // 2 and 3 are done in this method  
            addRowToTable(tempTable, templateRow, replacements);  
        }  
  
        // 4. remove the template row  
        tempTable.getContent().remove(templateRow);  
    } 
	}
	
	private static Tbl getTemplateTable(List<Object> tables, String templateKey) throws Docx4JException, JAXBException {  
	    for (Iterator<Object> iterator = tables.iterator(); iterator.hasNext();) {  
	        Object tbl = iterator.next();  
	        List<?> textElements = getAllElementFromObject(tbl, Text.class);  
	        for (Object text : textElements) {  
	            Text textElement = (Text) text;  
	            if (textElement.getValue() != null && textElement.getValue().equals(templateKey))  
	                return (Tbl) tbl;  
	        }  
	    }  
	    return null;  
	} 
	
	private static void addRowToTable(Tbl reviewtable, Tr templateRow, Map<String, String> replacements) {  
	    Tr workingRow = (Tr) XmlUtils.deepCopy(templateRow);  
	    List<?> textElements = getAllElementFromObject(workingRow, Text.class);  
	    for (Object object : textElements) {  
	        Text text = (Text) object;  
	        String replacementValue = (String) replacements.get(text.getValue());  
	        if (replacementValue != null)  
	            text.setValue(replacementValue);  
	    }  
	  
	    reviewtable.getContent().add(workingRow);  
	}  
	
	
	
	public static R newImage( WordprocessingMLPackage wordMLPackage,
			byte[] bytes,
			String filenameHint, String altText) throws Exception {
			int id1=(int) ((Math.random()*1000)*(Math.random()*1000));
			int id2=(int) ((Math.random()*1000)*(Math.random()*1000));
			// BinaryPartAbstractImage imagePart = BinaryPartAbstractImage.createImagePart(wordMLPackage, new File(file));
			BinaryPartAbstractImage imagePart = BinaryPartAbstractImage.createImagePart(wordMLPackage, bytes);

			Inline inline = imagePart.createImageInline( filenameHint, altText, 
			id1, id2, false);

			// Now add the inline in w:p/w:r/w:drawing
			ObjectFactory factory = Context.getWmlObjectFactory();
			R run = factory.createR();	
			org.docx4j.wml.Drawing drawing = factory.createDrawing();	
			run.getContent().add(drawing);	
			drawing.getAnchorOrInline().add(inline);
			bytes=null;
			imagePart=null;
			return run;

			} 
	
	/** 
	 * 将图片从文件对象转换成字节数组. 
	 * @param file  将要转换的文件 
	 * @return      包含图片字节数据的字节数组 
	 * @throws FileNotFoundException 
	 * @throws IOException 
	 */  
	public static byte[] convertImageToByteArray(File file)  throws FileNotFoundException, IOException {  
		InputStream is = new FileInputStream(file );  
		long length = file.length();  
		// 不能使用long类型创建数组, 需要用int类型.  
		if (length > Integer.MAX_VALUE) {  
			System.out.println("File too large!!");  
		}  
		byte[] bytes = new byte[(int)length];  
		int offset = 0;  
		int numRead = 0;  
		while (offset < bytes.length && (numRead=is.read(bytes, offset, bytes.length-offset)) >= 0) {  
			offset += numRead;  
		}  
		// 确认所有的字节都没读取  
		if (offset < bytes.length) {  
			System.out.println("Could not completely read file " +file.getName());  
		}  
		is.close();  
		return bytes;  
	}  
	
	
	public static void replaceImage(WordprocessingMLPackage wordMLPackage,
			String replace,
			byte[] bytes,
			String filenameHint, String altText) throws Exception{
			List texts = getAllElementFromObject(wordMLPackage.getMainDocumentPart(), Text.class); 
			for (Object text : texts) {
			Text content = (Text) text; 
			if(content.getValue().equals(replace)){
			R r=(R) content.getParent();
			r.getContent().clear();
			P p=(P) r.getParent();
			p.getContent().add(newImage( wordMLPackage, bytes, filenameHint, altText));
			}
		}
	}
}
